## mingw-w64-dosbox-staging-0.82.1-1.src.tar.zst

=== src/CMakeLists.txt ===
add_subdirectory(capture)
add_subdirectory(cpu)
add_subdirectory(debug)
add_subdirectory(dos)
add_subdirectory(fpu)
add_subdirectory(gui)
add_subdirectory(hardware)
add_subdirectory(ints)
add_subdirectory(libs)
add_subdirectory(midi)
add_subdirectory(misc)
add_subdirectory(shell)

=== contrib/icons/Makefile ===
.PHONY: help png windows macos linux clean

PNG_DIR = png

WINDOWS_DIR = windows

MACOS_DIR = macos
MACOS_ICON_1024 = $(MACOS_DIR)/dosbox-staging-1024.png
MACOS_ICONSET_DIR = $(MACOS_DIR)/dosbox-staging.iconset

help:
	@echo "Re-generate icons in platform specific formats, or install icons on Linux."
	@echo ""
	@echo "Available targets:"
	@echo "  png     - re-generate small PNG icons from the SVG sources"
	@echo "  windows - re-generate Windows .ico file from the PNG icons"
	@echo "  macos   - re-generate macOS .icns file from the macOS source PNG"
	@echo "  all     - re-generate all (in above the listed order)"
	@echo ""
	@echo "To install the icons on Linux:"
	@echo "  make install              # install icons to \$${DESTDIR}/usr/local/share/icons/..."
	@echo "  make install prefix=/usr  # install icons to \$${DESTDIR}/usr/share/icons/..."
	@echo "  make install datadir=foo  # install icons to \$${DESTDIR}foo/icons/..."

all: png windows macos

##
#  Re-generate small PNG icons from the SVG sources.
#  These are used on Linux as fallback bitmap icons and to build the Windows
#  .ico file.
#
#  Needs rsvg-convert from the librsvg package.
#
png:
	rsvg-convert -h  16 svg/dosbox-staging-16.svg > $(PNG_DIR)/icon_16.png
	rsvg-convert -h  24 svg/dosbox-staging-24.svg > $(PNG_DIR)/icon_24.png
	rsvg-convert -h  32 svg/dosbox-staging-32.svg > $(PNG_DIR)/icon_32.png

	# Some desktop environments expect a 22x22 icon (e.g., KDE Plasma).
	# Rendering this from the SVG optimised for 24x24px looks good enough.
	rsvg-convert -h  22 svg/dosbox-staging-24.svg > $(PNG_DIR)/icon_22.png

	rsvg-convert -h   48 svg/dosbox-staging.svg   > $(PNG_DIR)/icon_48.png
	rsvg-convert -h   96 svg/dosbox-staging.svg   > $(PNG_DIR)/icon_96.png
	rsvg-convert -h  128 svg/dosbox-staging.svg   > $(PNG_DIR)/icon_128.png
	rsvg-convert -h  256 svg/dosbox-staging.svg   > $(PNG_DIR)/icon_256.png
	rsvg-convert -h  512 svg/dosbox-staging.svg   > $(PNG_DIR)/icon_512.png
	rsvg-convert -h 1024 svg/dosbox-staging.svg   > $(PNG_DIR)/icon_1024.png

##
#  Re-generate Window .ico file from the PNG icons.
#
#  Needs icotool from the icoutils packags (there's no good Windows native
#  CLI tool for this).
#
windows:
	icotool -c $(PNG_DIR)/icon_256.png \
	           $(PNG_DIR)/icon_48.png \
	           $(PNG_DIR)/icon_32.png \
	           $(PNG_DIR)/icon_24.png \
	           $(PNG_DIR)/icon_16.png \
	        -o $(WINDOWS_DIR)/dosbox-staging.ico

##
#  Re-generate macOS .icns file from the 1024x1024 macOS source PNG.
#
#  Needs sips & iconutil (available on macOS out-of-the-box).
#
macos:
	mkdir -p $(MACOS_ICONSET_DIR)

	sips -z  16  16 $(MACOS_ICON_1024) --out "$(MACOS_ICONSET_DIR)/icon_16x16.png"
	sips -z  32  32 $(MACOS_ICON_1024) --out "$(MACOS_ICONSET_DIR)/icon_16x16@2x.png"
	sips -z  32  32 $(MACOS_ICON_1024) --out "$(MACOS_ICONSET_DIR)/icon_32x32.png"
	sips -z  64  64 $(MACOS_ICON_1024) --out "$(MACOS_ICONSET_DIR)/icon_32x32@2x.png"
	sips -z 128 128 $(MACOS_ICON_1024) --out "$(MACOS_ICONSET_DIR)/icon_128x128.png"
	sips -z 256 256 $(MACOS_ICON_1024) --out "$(MACOS_ICONSET_DIR)/icon_128x128@2x.png"
	sips -z 256 256 $(MACOS_ICON_1024) --out "$(MACOS_ICONSET_DIR)/icon_256x256.png"
	sips -z 512 512 $(MACOS_ICON_1024) --out "$(MACOS_ICONSET_DIR)/icon_256x256@2x.png"
	sips -z 512 512 $(MACOS_ICON_1024) --out "$(MACOS_ICONSET_DIR)/icon_512x512.png"

	cp $(MACOS_ICON_1024) $(MACOS_ICONSET_DIR)/icon_512x512@2x.png
	cp $(MACOS_ICON_1024) $(MACOS_ICONSET_DIR)/icon_1024x1024.png

	iconutil -c icns $(MACOS_ICONSET_DIR)

##
#  Install icons on Linux.
##
#  Freedesktop icons (for Linux or other OSes) often are placed in 'hicolor'
#  directory in /usr/share/icons/ or /usr/local/share/icons/.
#
#  Users can override them by placing icons in ~/.local/share/icons/
#
#  This is not strictly necessary (just placing scalable icon is enough, but
#  some there are some corner cases where small PNG bitmap icons look better).
#
prefix = /usr/local
datadir = $(prefix)/share
install:
	mkdir -m 0755 -p "$(DESTDIR)$(datadir)/icons/hicolor/16x16/apps/"
	mkdir -m 0755 -p "$(DESTDIR)$(datadir)/icons/hicolor/22x22/apps/"
	mkdir -m 0755 -p "$(DESTDIR)$(datadir)/icons/hicolor/24x24/apps/"
	mkdir -m 0755 -p "$(DESTDIR)$(datadir)/icons/hicolor/32x32/apps/"
	mkdir -m 0755 -p "$(DESTDIR)$(datadir)/icons/hicolor/48x48/apps/"
	mkdir -m 0755 -p "$(DESTDIR)$(datadir)/icons/hicolor/96x96/apps/"
	mkdir -m 0755 -p "$(DESTDIR)$(datadir)/icons/hicolor/128x128/apps/"
	mkdir -m 0755 -p "$(DESTDIR)$(datadir)/icons/hicolor/256x256/apps/"
	mkdir -m 0755 -p "$(DESTDIR)$(datadir)/icons/hicolor/512x512/apps/"
	mkdir -m 0755 -p "$(DESTDIR)$(datadir)/icons/hicolor/1024x1024/apps/"
	mkdir -m 0755 -p "$(DESTDIR)$(datadir)/icons/hicolor/scalable/apps"

	install -p -m 0644 $(PNG_DIR)/icon_16.png "$(DESTDIR)$(datadir)/icons/hicolor/16x16/apps/org.dosbox-staging.dosbox-staging.png"
	install -p -m 0644 $(PNG_DIR)/icon_22.png "$(DESTDIR)$(datadir)/icons/hicolor/22x22/apps/org.dosbox-staging.dosbox-staging.png"
	install -p -m 0644 $(PNG_DIR)/icon_24.png "$(DESTDIR)$(datadir)/icons/hicolor/24x24/apps/org.dosbox-staging.dosbox-staging.png"
	install -p -m 0644 $(PNG_DIR)/icon_32.png "$(DESTDIR)$(datadir)/icons/hicolor/32x32/apps/org.dosbox-staging.dosbox-staging.png"
	install -p -m 0644 $(PNG_DIR)/icon_48.png "$(DESTDIR)$(datadir)/icons/hicolor/48x48/apps/org.dosbox-staging.dosbox-staging.png"
	install -p -m 0644 $(PNG_DIR)/icon_96.png "$(DESTDIR)$(datadir)/icons/hicolor/96x96/apps/org.dosbox-staging.dosbox-staging.png"
	install -p -m 0644 $(PNG_DIR)/icon_128.png "$(DESTDIR)$(datadir)/icons/hicolor/128x128/apps/org.dosbox-staging.dosbox-staging.png"
	install -p -m 0644 $(PNG_DIR)/icon_256.png "$(DESTDIR)$(datadir)/icons/hicolor/256x256/apps/org.dosbox-staging.dosbox-staging.png"
	install -p -m 0644 $(PNG_DIR)/icon_512.png "$(DESTDIR)$(datadir)/icons/hicolor/512x512/apps/org.dosbox-staging.dosbox-staging.png"
	install -p -m 0644 $(PNG_DIR)/icon_1024.png "$(DESTDIR)$(datadir)/icons/hicolor/1024x1024/apps/org.dosbox-staging.dosbox-staging.png"
	install -p -m 0644 svg/dosbox-staging.svg "$(DESTDIR)$(datadir)/icons/hicolor/scalable/apps/org.dosbox-staging.dosbox-staging.svg"

clean:
	rm -rf $(MACOS_ICONSET_DIR)

=== contrib/static-fluidsynth/Makefile ===
##
#  Fetch the latest dependencies from upstream
#  -------------------------------------------
FLUIDSYNTH_ARCHIVE = fluidsynth-master.tar.gz
FLUIDSYNTH_URL = https://github.com/FluidSynth/fluidsynth/archive/master.tar.gz

##
#  Common commands and arguments
#  -----------------------------
THREADS = $(shell nproc || echo 4)
CURL_FLAGS = --progress-bar
CURL = curl --location $(CURL_FLAGS)
WGET_FLAGS = --no-verbose --progress=bar
WGET = wget --no-clobber $(WGET_FLAGS)
EXTRACT = tar --strip 1 -zxof
DIR := ${CURDIR}

##
#  Everything-targets
#  ------------------
.PHONY: all clean distclean
all: fluidsynth
clean: fluidsynth/clean
distclean:
	rm -rf bin fluidsynth include lib* share *.gz

##
#  Re-useable download function that tries curl, then wget, and then
#  prompts the user to manually download the files.  Note that if
#  one download fails then we assume they all will and therefore
#  give the user the full list up-front.
#
define download
	echo "Downloading $(URL) to ./$@"                                        \
	&& $(CURL) "$(URL)" -o "$@"                                              \
	|| $(WGET) "$(URL)" -O "$@"                                              \
	|| ( rm -f "$@"                                                          \
	     && echo ""                                                          \
	     && echo "DOWNLOAD FAILURE"                                          \
	     && echo "~~~~~~~~~~~~~~~~"                                          \
	     && echo "Please manually download the following, then re-run make:" \
	     && echo "  - $(FLUIDSYNTH_URL) to ./$(FLUIDSYNTH_ARCHIVE)"          \
	     && echo ""                                                          \
	     && echo "Alternatively, you can use your own curl or wget"          \
	     && echo "arguments by passing CURL_FLAGS=\"--my-args\" and"         \
	     && echo "WGET_FLAGS=\"--my-flags\" to the make command."            \
	     && echo ""                                                          \
	     && echo "For example, disable certificate checking:"                \
	     && echo "    make CURL_FLAGS=\"-k\""                                \
	     && echo "    make WGET_FLAGS=\"--no-check-certificate\""            \
	     && echo ""                                                          \
	   )
endef

##
#  FluidSynth Library
#  -------------------
fluidsynth: fluidsynth-message

fluidsynth: lib/libfluidsynth.a

$(FLUIDSYNTH_ARCHIVE):
	$(eval URL := $(FLUIDSYNTH_URL))
	@$(download)

fluidsynth/build: $(FLUIDSYNTH_ARCHIVE)
	@test -f $@ \
	|| (mkdir -p fluidsynth/build \
	&& $(EXTRACT) $(FLUIDSYNTH_ARCHIVE) -C fluidsynth) \
	&& sed -i -E 's|^(Libs.+)|\1 $(GLIB_LIBS)|;s|^(Cflags.+)|\1 $(GLIB_CFLAGS)|' \
		fluidsynth/fluidsynth.pc.in

fluidsynth/build/Makefile: fluidsynth/build
	cd fluidsynth \
	&& cd build \
	&& cmake \
	-DBUILD_SHARED_LIBS=0 \
	-DCMAKE_BUILD_TYPE=Release \
	-DCMAKE_INSTALL_PREFIX="$(DIR)" \
	-DOpenMP_gomp_LIBRARY="" \
	-DLIB_SUFFIX="" \
	-Denable-alsa=0 \
	-Denable-aufile=0 \
	-Denable-coreaudio=0 \
	-Denable-coremidi=0 \
	-Denable-dbus=0 \
	-Denable-dsound=0 \
	-Denable-floats=1 \
	-Denable-ipv6=0 \
	-Denable-jack=0 \
	-Denable-ladspa=0 \
	-Denable-lash=0 \
	-Denable-libinstpatch=0 \
	-Denable-libsndfile=0 \
	-Denable-midishare=0 \
	-Denable-network=0 \
	-Denable-oss=0 \
	-Denable-portaudio=0 \
	-Denable-pulseaudio=0 \
	-Denable-readline=0 \
	-Denable-sdl2=0 \
	-Denable-systemd=0 \
	-Denable-wasapi=0 \
	-Denable-waveout=0 \
	-Denable-winmidi=0 \
	..

lib/libfluidsynth.a: fluidsynth/build/Makefile
	cd fluidsynth/build \
	&& $(MAKE) -j$(THREADS) \
	&& $(MAKE) check \
	&& mkdir -p ../../include/ ../../lib \
	&& cp -rv ../include/* ../../include/ \
	&& cp -rv include/* ../../include/ \
	&& rm -f ../../lib/libfluidsynth.a \
	&& ar -qc ../../lib/libfluidsynth.a src/CMakeFiles/libfluidsynth-OBJ.dir/*/*.o \
	&& ranlib ../../lib/libfluidsynth.a


define FLUIDSYNTH_EXPORTS

Export the following to configure dosbox-staging without pkg-config
~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~
export FLUIDSYNTH_CFLAGS="-I$(CURDIR)/include $(GLIB_CFLAGS)"
export FLUIDSYNTH_LIBS="$(CURDIR)/lib/libfluidsynth.a $(GLIB_LIBS) -lm"

Export the following to configure dosbox-staging with pkg-config
~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~
export PKG_CONFIG_PATH="$(CURDIR)/fluidsynth/build"
endef

GLIB_LIBS = $(shell pkg-config --libs gthread-2.0 glib-2.0)
GLIB_CFLAGS = $(shell pkg-config --cflags gthread-2.0 glib-2.0)
.PHONY: fluidsynth-message
fluidsynth-message: lib/libfluidsynth.a
	$(info $(FLUIDSYNTH_EXPORTS))

fluidsynth/clean:
	rm -rf fluidsynth/build

=== contrib/static-opus/Makefile ===
##
#  Fetch the latest dependencies from upstream
#  -------------------------------------------
OGG_ARCHIVE = ogg-master.tar.gz
OGG_URL = https://github.com/xiph/ogg/archive/master.tar.gz

OPUS_ARCHIVE = opus-master.tar.gz
OPUS_URL = https://github.com/xiph/opus/archive/master.tar.gz

OPUSFILE_ARCHIVE = opusfile-master.tar.gz
OPUSFILE_URL = https://github.com/xiph/opusfile/archive/master.tar.gz

##
#  We use speex's pkg.m4 to work around a bug in opusfile's autotools config
#  that still depends on pkgconfig even if DEPS_ env flags are present.
#  Mingw 1.0 (Windows) does not provide pkg-config, so we need to avoid it.
#
OPUSFILE_PKG_URL = https://raw.githubusercontent.com/xiph/speex/master/m4/pkg.m4

##
#  Common commands and arguments
#  -----------------------------
THREADS = $(shell nproc || echo 4)
CURL_FLAGS = --progress-bar
CURL = curl --location $(CURL_FLAGS)
WGET_FLAGS = --no-verbose --progress=bar
WGET = wget --no-clobber $(WGET_FLAGS)
EXTRACT = tar --strip 1 -zxof

##
#  The audio-codecs rely on accurate floating-point calculations
#  and will fail to build if they detect too agressive optimizations
#  such as Ofast or ffast-math; therefore we strip just these flags
#  and step-down -Ofast to -O3 as an acceptable fallback.
#
CFLAGS:= $(subst -Ofast,-O3,$(CFLAGS))
CFLAGS:= $(filter-out -ffast-math,$(CFLAGS))
CFLAGS:= $(filter-out -funsafe-math-optimizations,$(CFLAGS))

CXXFLAGS:= $(subst -Ofast,-O3,$(CXXFLAGS))
CXXFLAGS:= $(filter-out -ffast-math,$(CXXFLAGS))
CXXFLAGS:= $(filter-out -funsafe-math-optimizations,$(CXXFLAGS))

LDFLAGS:= $(subst -Ofast,-O3,$(LDLAGS))
LDFLAGS:= $(filter-out -ffast-math,$(LDFLAGS))
LDFLAGS:= $(filter-out -funsafe-math-optimizations,$(LDFLAGS))


##
#  Everything-targets
#  ------------------
.PHONY: all clean distclean
all: ogg opus opusfile
clean: ogg/clean opus/clean opusfile/clean
distclean:
	rm -rf ogg opus opusfile include lib share pkg.m4 *.gz

##
#  Re-useable download function that tries curl, then wget, and then
#  prompts the user to manually download the files.  Note that if
#  one download fails then we assume they all will and therefore
#  give the user the full list up-front.
#
define download
	echo "Downloading $(URL) to ./$@"                                        \
	&& $(CURL) "$(URL)" -o "$@"                                              \
	|| $(WGET) "$(URL)" -O "$@"                                              \
	|| ( rm -f "$@"                                                          \
	     && echo ""                                                          \
	     && echo "DOWNLOAD FAILURE"                                          \
	     && echo "~~~~~~~~~~~~~~~~"                                          \
	     && echo "Please manually download the following, then re-run make:" \
	     && echo "  - $(OGG_URL) to ./$(OGG_ARCHIVE)"                        \
	     && echo "  - $(OPUS_URL) to ./$(OPUS_ARCHIVE)"                      \
	     && echo "  - $(OPUSFILE_URL) to ./$(OPUSFILE_ARCHIVE)"              \
	     && echo "  - $(OPUSFILE_PKG_URL) to ./pkg.m4"                       \
	     && echo ""                                                          \
	     && echo "Alternatively, you can use your own curl or wget"          \
	     && echo "arguments by passing CURL_FLAGS=\"--my-args\" and"         \
	     && echo "WGET_FLAGS=\"--my-flags\" to the make command."            \
	     && echo ""                                                          \
	     && echo "For example, disable certificate checking:"                \
	     && echo "    make CURL_FLAGS=\"-k\""                                \
	     && echo "    make WGET_FLAGS=\"--no-check-certificate\""            \
	     && echo ""                                                          \
	   )
endef

##
#  Ogg Library
#  -----------
ogg: lib/libogg.a

$(OGG_ARCHIVE):
	$(eval URL := $(OGG_URL))
	@$(download)

ogg/autogen.sh: $(OGG_ARCHIVE)
	@test -f $@ \
	|| ( mkdir -p ogg \
	&& $(EXTRACT) $(OGG_ARCHIVE) -C ogg )

ogg/configure: ogg/autogen.sh
	cd ogg \
	&& mkdir -p m4 \
	&& ./autogen.sh

ogg/Makefile: ogg/configure
	cd ogg \
	&& ./configure --disable-shared

lib/libogg.a: ogg/Makefile
	cd ogg \
	&& $(MAKE) -j$(THREADS) \
	&& mkdir -p ../include/ogg ../lib \
	&& cp -v include/ogg/*.h ../include/ogg \
	&& cp -v src/.libs/libogg.a ../lib

ogg/clean:
	cd ogg \
	&& $(MAKE) clean \
	&& rm -f configure Makefile

##
#  Opus Library
#  ------------
opus: lib/libopus.a

$(OPUS_ARCHIVE):
	$(eval URL := $(OPUS_URL))
	@$(download)

opus/autogen.sh: $(OPUS_ARCHIVE)
	@test -f $@ \
	|| ( mkdir -p opus \
	&& $(EXTRACT) $(OPUS_ARCHIVE) -C opus )

opus/configure: opus/autogen.sh
	cd opus \
	&& mkdir -p m4 \
	&& ./autogen.sh

opus/Makefile: opus/configure
	cd opus \
	&& ./configure --disable-shared --disable-extra-programs --disable-doc

lib/libopus.a: opus/Makefile
	cd opus \
	&& $(MAKE) -j$(THREADS) \
	&& mkdir -p ../include/opus ../lib \
	&& cp -v include/*.h ../include/opus \
	&& cp -v .libs/libopus.a ../lib

opus/clean:
	cd opus \
	&& $(MAKE) clean \
	&& rm -f configure Makefile

##
#  Opusfile Library
#  ----------------
opusfile: opusfile-message

pkg.m4:
	$(eval URL := $(OPUSFILE_PKG_URL))
	@$(download)

$(OPUSFILE_ARCHIVE):
	$(eval URL := $(OPUSFILE_URL))
	@$(download)

opusfile/autogen.sh: $(OPUSFILE_ARCHIVE)
	@test -f $@ \
	|| ( mkdir -p opusfile \
	&& $(EXTRACT) $(OPUSFILE_ARCHIVE) -C opusfile )

opusfile/configure: opusfile/autogen.sh pkg.m4
	cd opusfile \
	&& mkdir -p m4 \
	&& cp ../pkg.m4 m4/ \
	&& ./autogen.sh

opusfile/Makefile: opusfile/configure lib/libopus.a lib/libogg.a
	cd opusfile && \
	DEPS_LIBS="-L../lib -lopus -logg" \
	DEPS_CFLAGS="-I../include -I../include/opus -I../include/ogg" \
	./configure --disable-shared --disable-doc --disable-http --disable-examples

# We run make twice below. We hide the output of the first run because the
# auto-tools generated Makefile launches sed and libtool without quoting the
# current working directory, so those fail when run inside a directory structure
# containing one or more spaces.
#
# Regardless of the sed/libtool issue, if all went well the resulting library will
# exist, which is why we run make a second time. The second make pass doesn't
# rerun the sed and libtool comands, so it acts as a safety check. If there's a
# actual build problem with the source code then it will be caught in this
# second make run and fail without producing a library.
#
lib/libopusfile.a: opusfile/Makefile
	cd opusfile \
	&& ( $(MAKE) -j$(THREADS) > make.log 2>&1 || $(MAKE) ) \
	&& mkdir -p ../include/ ../lib \
	&& cp -v include/*.h ../include/opus \
	&& cp -v .libs/*.a ../lib

define OPUSFILE_EXPORTS

Export the following to configure DOSBox without pkg-config
~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~
export OPUSFILE_CFLAGS="-I$(CURDIR)/include -I$(CURDIR)/include/opus"
export OPUSFILE_LIBS="$(CURDIR)/lib/libopusfile.a $(CURDIR)/lib/libogg.a $(CURDIR)/lib/libopus.a -lm"
endef

.PHONY: opusfile-message
opusfile-message: lib/libopusfile.a
	$(info $(OPUSFILE_EXPORTS))

opusfile/clean:
	cd opusfile \
	&& $(MAKE) clean \
	&& rm -f configure Makefile

=== src/capture/CMakeLists.txt ===
add_library(libcapture STATIC
		capture.cpp
		capture_audio.cpp
		capture_midi.cpp
		capture_video.cpp

		image/image_capturer.cpp
		image/image_decoder.cpp
		image/image_saver.cpp
		image/image_scaler.cpp
		image/png_writer.cpp
)

find_package(PNG REQUIRED)

target_link_libraries(libcapture PRIVATE
		loguru
		zmbv
		PNG::PNG
		$<IF:$<TARGET_EXISTS:SDL2::SDL2>,SDL2::SDL2,SDL2::SDL2-static>
)

=== src/cpu/CMakeLists.txt ===
add_library(libcpu STATIC
		callback.cpp
		core_dyn_x86.cpp
		core_dynrec.cpp
		core_full.cpp
		core_normal.cpp
		core_prefetch.cpp
		core_simple.cpp
		cpu.cpp
		flags.cpp
		mmx.cpp
		modrm.cpp
		paging.cpp
)

target_link_libraries(libcpu PRIVATE
		$<IF:$<TARGET_EXISTS:SDL2::SDL2>,SDL2::SDL2,SDL2::SDL2-static>
		simde
)

if (C_DEBUG)
	target_link_libraries(libcpu PRIVATE libdebug)
endif()

=== src/hardware/CMakeLists.txt ===
add_library(libhardware STATIC
		input/intel8042.cpp
		input/intel8255.cpp
		input/keyboard.cpp
		input/keyboard_scancodes.cpp
		input/mouse.cpp
		input/mouse_common.cpp
		input/mouse_config.cpp
		input/mouse_interfaces.cpp
		input/mouse_manymouse.cpp
		input/mouseif_dos_driver.cpp
		input/mouseif_ps2_bios.cpp
		input/mouseif_virtual_machines.cpp
		mame/saa1099.cpp
		mame/sn76496.cpp
		serialport/directserial.cpp
		serialport/libserial.cpp
		serialport/misc_util.cpp
		serialport/nullmodem.cpp
		serialport/serialdummy.cpp
		serialport/serialmouse.cpp
		serialport/serialport.cpp
		serialport/softmodem.cpp
		adlib_gold.cpp
		cmos.cpp
		covox.cpp
		compressor.cpp
		disney.cpp
		dma.cpp
		envelope.cpp
		gameblaster.cpp
		gus.cpp
		ide.cpp
		innovation.cpp
		imfc.cpp
		iohandler.cpp
		iohandler_containers.cpp
		ipx.cpp
		ipxserver.cpp
		joystick.cpp
		lpt_dac.cpp
		memory.cpp
		mixer.cpp
		mpu401.cpp
		ne2000.cpp
		opl.cpp
		opl_capture.cpp
		pci_bus.cpp
		pcspeaker.cpp
		pcspeaker_discrete.cpp
		pcspeaker_impulse.cpp
		pic.cpp
		ps1audio.cpp
		reelmagic/driver.cpp
		reelmagic/player.cpp
		reelmagic/video_mixer.cpp
		sblaster.cpp
		ston1_dac.cpp
		tandy_sound.cpp
		timer.cpp
		vga.cpp
		vga_attr.cpp
		vga_crtc.cpp
		vga_dac.cpp
		vga_draw.cpp
		vga_gfx.cpp
		vga_memory.cpp
		vga_misc.cpp
		vga_other.cpp
		vga_paradise.cpp
		vga_s3.cpp
		vga_seq.cpp
		vga_tseng.cpp
		vga_xga.cpp
		virtualbox.cpp
		vmware.cpp
		voodoo.cpp
)

pkg_check_modules(SPEEXDSP REQUIRED IMPORTED_TARGET speexdsp)

find_package(iir CONFIG REQUIRED)
find_package(SDL2_net CONFIG REQUIRED)

target_link_libraries(libhardware PRIVATE
		libesfmu
		libresidfp
		libym7128bemu
		libtalchorus
		libnuked
		libints
		libgui
		libmidi
		libshell
		PkgConfig::SPEEXDSP
		iir::iir
		$<IF:$<TARGET_EXISTS:SDL2_net::SDL2_net>,SDL2_net::SDL2_net,SDL2_net::SDL2_net-static>)

=== src/libs/PDCurses/CMakeLists.txt ===
add_library(libpdcurses STATIC
		pdcurses/addch.c
		pdcurses/addchstr.c
		pdcurses/addstr.c
		pdcurses/attr.c
		pdcurses/beep.c
		pdcurses/bkgd.c
		pdcurses/border.c
		pdcurses/clear.c
		pdcurses/color.c
		pdcurses/debug.c
		pdcurses/delch.c
		pdcurses/deleteln.c
		pdcurses/getch.c
		pdcurses/getstr.c
		pdcurses/getyx.c
		pdcurses/inch.c
		pdcurses/inchstr.c
		pdcurses/initscr.c
		pdcurses/inopts.c
		pdcurses/insch.c
		pdcurses/insstr.c
		pdcurses/instr.c
		pdcurses/kernel.c
		pdcurses/keyname.c
		pdcurses/mouse.c
		pdcurses/move.c
		pdcurses/outopts.c
		pdcurses/overlay.c
		pdcurses/pad.c
		pdcurses/panel.c
		pdcurses/printw.c
		pdcurses/refresh.c
		pdcurses/scanw.c
		pdcurses/scr_dump.c
		pdcurses/scroll.c
		pdcurses/slk.c
		pdcurses/termattr.c
		pdcurses/touch.c
		pdcurses/util.c
		pdcurses/window.c
		sdl2_queue/pdcclip.cpp
		sdl2_queue/pdcdisp.cpp
		sdl2_queue/pdcgetsc.cpp
		sdl2_queue/pdckbd.cpp
		sdl2_queue/pdcscrn.cpp
		sdl2_queue/pdcsetsc.cpp
		sdl2_queue/pdcutil.cpp
)

target_include_directories(libpdcurses PUBLIC . pdcurses)
target_link_libraries(libpdcurses PRIVATE $<IF:$<TARGET_EXISTS:SDL2::SDL2>,SDL2::SDL2,SDL2::SDL2-static>)

=== src/libs/residfp/CMakeLists.txt ===
add_library(libresidfp STATIC
		resample/SincResampler.cpp
		Dac.cpp
		EnvelopeGenerator.cpp
		ExternalFilter.cpp
		Filter.cpp
		Filter6581.cpp
		Filter8580.cpp
		FilterModelConfig.cpp
		FilterModelConfig6581.cpp
		FilterModelConfig8580.cpp
		Integrator6581.cpp
		Integrator8580.cpp
		OpAmp.cpp
		SID.cpp
		Spline.cpp
		WaveformCalculator.cpp
		WaveformGenerator.cpp
)

target_include_directories(libresidfp PUBLIC ..)

=== src/libs/whereami/CMakeLists.txt ===
add_library(libwhereami STATIC whereami.c)
target_include_directories(libwhereami PUBLIC .)

=== src/hardware/reelmagic/tools/Makefile ===
## Copyright (C) 2022 Jon Dennis
##
## This program is free software; you can redistribute it and/or modify
## it under the terms of the GNU General Public License as published by
## the Free Software Foundation; either version 2 of the License, or
## (at your option) any later version.
##
## This program is distributed in the hope that it will be useful,
## but WITHOUT ANY WARRANTY; without even the implied warranty of
## MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
## GNU General Public License for more details.
##
## You should have received a copy of the GNU General Public License
## along with this program; if not, write to the Free Software
## Foundation, Inc., 59 Temple Place - Suite 330, Boston, MA 02111-1307, USA.

CFLAGS :=

ifeq ($(ENABLE_WINCOMPAT),1) 
  CFLAGS := -include wincompat.h
else
  CFLAGS :=
endif

OUTPUTS := $(patsubst %.c,%,$(wildcard *.c))
OUTPUTS_EXE := $(patsubst %.c,%.exe,$(wildcard *.c))

HEADERS := $(wildcard *.h)

.PHONY: all clean

all:
	$(MAKE) $(OUTPUTS)

clean: 
	rm -f $(OUTPUTS) $(OUTPUTS_EXE)

%: %.c $(HEADERS)
	$(CC) $(CFLAGS) -O3 -Wall -s -o "$@" "$<"

=== PKGBUILD ===
# Maintainer: Christoph Reiter <reiter.christoph@gmail.com>

_realname=dosbox-staging
pkgbase=mingw-w64-${_realname}
pkgname=("${MINGW_PACKAGE_PREFIX}-${_realname}")
pkgver=0.82.1
pkgrel=1
pkgdesc="Emulator with builtin DOS for running DOS Games (mingw-w64)"
arch=('any')
mingw_arch=('mingw64' 'ucrt64' 'clang64' 'clangarm64')
url='https://github.com/dosbox-staging/dosbox-staging'
license=('spdx:GPL-2.0-or-later')
provides=("${MINGW_PACKAGE_PREFIX}-dosbox")
replaces=("${MINGW_PACKAGE_PREFIX}-dosbox")
conflicts=("${MINGW_PACKAGE_PREFIX}-dosbox")
depends=(
    "${MINGW_PACKAGE_PREFIX}-fluidsynth"
    "${MINGW_PACKAGE_PREFIX}-libpng"
    "${MINGW_PACKAGE_PREFIX}-opusfile"
    "${MINGW_PACKAGE_PREFIX}-SDL2"
    "${MINGW_PACKAGE_PREFIX}-SDL2_image"
    "${MINGW_PACKAGE_PREFIX}-SDL2_net"
    "${MINGW_PACKAGE_PREFIX}-zlib"
    "${MINGW_PACKAGE_PREFIX}-libslirp"
    "${MINGW_PACKAGE_PREFIX}-munt-mt32emu"
    "${MINGW_PACKAGE_PREFIX}-speexdsp"
    "${MINGW_PACKAGE_PREFIX}-iir"
)
makedepends=("${MINGW_PACKAGE_PREFIX}-cc"
             "${MINGW_PACKAGE_PREFIX}-meson"
             "${MINGW_PACKAGE_PREFIX}-ninja"
             "${MINGW_PACKAGE_PREFIX}-pkgconf")
source=("https://github.com/dosbox-staging/dosbox-staging/archive/refs/tags/v${pkgver}.tar.gz")
sha256sums=('9d943d6610b6773cb0b27ba24904c85459757fbbfa0f34c72e76082132f77568')
noextract=("v${pkgver}.tar.gz")

prepare() {
  bsdtar -xf "v${pkgver}.tar.gz" || bsdtar -xf "v${pkgver}.tar.gz"

  cd "${_realname}-${pkgver}"
  echo -e "#!python\nprint('${pkgver}')" > scripts/get-version.sh
}

build() {
  mkdir -p build-${MSYSTEM} && cd build-${MSYSTEM}

  declare -a extra_config
  if check_option "debug" "n"; then
    extra_config+=("--buildtype=release")
  else
    extra_config+=("--buildtype=debug")
  fi

  MSYS2_ARG_CONV_EXCL="--prefix=" \
  ${MINGW_PREFIX}/bin/meson \
    --prefix="${MINGW_PREFIX}" \
    --wrap-mode=nodownload \
    --auto-features=enabled \
    "${extra_config[@]}" \
    -Dunit_tests=disabled \
    -Ddefault_library=shared \
    ../${_realname}-${pkgver}

  ${MINGW_PREFIX}/bin/meson compile
}

check() {
  cd "${srcdir}/build-${MSYSTEM}"

  ${MINGW_PREFIX}/bin/meson test
}

package() {
  cd "${srcdir}/build-${MSYSTEM}"

  DESTDIR="${pkgdir}" ${MINGW_PREFIX}/bin/meson install

  install -Dm644 "${srcdir}/${_realname}-${pkgver}/LICENSE" "${pkgdir}${MINGW_PREFIX}/share/licenses/${_realname}/LICENSE"
}

=== contrib/linux/debian/control ===
Source: dosbox-staging
Section: otherosfs
Priority: optional
Maintainer: The DOSBox Staging Team <join.discord.with.WwAg3Xf@discord.gg>
Build-Depends: Populated by scripts/build-debian-package.sh
Standards-Version: 4.5.0
Homepage: https://www.dosbox-staging.org

Package: dosbox-staging
Architecture: any
Depends: ${shlibs:Depends}, ${misc:Depends}
Description: DOSBox Staging is a modern continuation of DOSBox
 It includes advanced features and the team uses current
 development practices. It is a (mostly) drop-in replacement
 for older DOSBox versions --- your existing configurations will
 continue to work, and you will have access to many advanced
 features.
